<#ibiztemplate>
TARGET=PSSUBSYSSERVICEAPIDE
</#ibiztemplate>
<#assign refDE=sys.getPSDataEntity(item.name)>
<#if refDE??>
package ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.domain.${refDE.getCodeName()};
import ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.filter.${refDE.getCodeName()}SearchContext;
import org.springframework.stereotype.Component;

    <#if item.getPSSubSysServiceAPI().getServicePath()??>
        <#if item.getPSSubSysServiceAPI().getServicePath() != '' >
            <#assign fullpath= item.getPSSubSysServiceAPI().getServicePath() + "/" + srfpluralize(item.getCodeName()?lower_case) >
        <#else>
            <#assign fullpath="/" + item.getPSSubSysServiceAPI().getCodeName()?lower_case + "/" + srfpluralize(item.getCodeName()?lower_case) >
        </#if>
    <#else>
        <#assign fullpath="/" + item.getPSSubSysServiceAPI().getCodeName()?lower_case + "/" + srfpluralize(item.getCodeName()?lower_case) >
    </#if>
/**
 * 实体[${item.codeName}] 服务对象接口
 */
@Component
public class ${item.codeName}Fallback implements ${item.codeName}FeignClient{

    <#if item.getPSSubSysServiceAPIDEMethods()??>
        <#list item.getPSSubSysServiceAPIDEMethods() as apiMethod>
            <#assign req_param_type=(apiMethod.getRequestParamType()!'')>
            <#assign req_param=(apiMethod.getRequestField()!'')>
            <#assign retval_type=(apiMethod.getRetvalType())!''>
            <#assign return_type='void'>
            <#if return_type?? && return_type!='' && retval_type !='VOID' && retval_type='ENTITY' ><#comment>由于无法获取到返回值类型，暂时通过请求参数类型确定返回值类型</#comment>
                <#assign return_type=item.codeName>
            </#if>
            <#if apiMethod.getActionType()=='DEACTION'><#comment>实体行为</#comment>
            <#--   ${return_type} ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
                <#if apiMethod.getCodeName()?lower_case == 'get'>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${item.getKeyDEField().getCodeName()?lower_case}}")-->
    public ${item.codeName} get(${srfjavatype(item.getKeyDEField().stdDataType)} ${item.getKeyDEField().getCodeName()?lower_case}){
            return null;
     }

                <#elseif apiMethod.getCodeName()?lower_case == 'remove'>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${item.getKeyDEField().getCodeName()?lower_case}}")-->
    public Boolean remove(${srfjavatype(item.getKeyDEField().stdDataType)} ${item.getKeyDEField().getCodeName()?lower_case}){
            return false;
     }
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Boolean removeBatch(Collection<${srfjavatype(item.getKeyDEField().stdDataType)}> idList){
            return false;
     }
                <#elseif apiMethod.getCodeName()?lower_case == 'create'>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}")-->
    public ${item.codeName} create(${item.codeName} ${item.codeName?lower_case}){
            return null;
     }
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Boolean createBatch(List<${item.codeName}> ${srfpluralize(item.getCodeName()?lower_case)}){
            return false;
     }
                <#elseif apiMethod.getCodeName()?lower_case == 'save'>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}")-->
    public Boolean save(${item.codeName} ${item.codeName?lower_case}){
            return false;
     }
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Boolean saveBatch(List<${item.codeName}> ${srfpluralize(item.getCodeName()?lower_case)}){
            return false;
     }
                <#elseif apiMethod.getCodeName()?lower_case == 'update'>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${item.getKeyDEField().getCodeName()?lower_case}}")-->
    public ${item.codeName} update(${srfjavatype(item.getKeyDEField().stdDataType)} ${item.getKeyDEField().getCodeName()?lower_case}, ${item.codeName} ${item.codeName?lower_case}){
            return null;
     }
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Boolean updateBatch(List<${item.codeName}> ${srfpluralize(item.getCodeName()?lower_case)}){
            return false;
     }

                <#elseif apiMethod.getCodeName()?lower_case == 'getdraft'>
    public ${item.codeName} getDraft(){
            return null;
    }


                <#elseif apiMethod.getCodeName()?lower_case == 'checkkey'>
    public Boolean checkKey(${item.codeName} ${item.codeName?lower_case}){
            return false;
     }

                <#elseif apiMethod.getCodeName()?lower_case == 'createbatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'updatebatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'removebatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'savebatch'>
                <#else>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${item.getKeyDEField().getCodeName()?lower_case}}/${apiMethod.getCodeName()?lower_case}")-->
    public ${item.codeName} ${apiMethod.getCodeName()?uncap_first}( ${srfjavatype(item.getKeyDEField().stdDataType)} ${item.getKeyDEField().getCodeName()?lower_case}, ${item.codeName} ${item.codeName?lower_case}){
            return null;
     }
                </#if>
            <#elseif apiMethod.getActionType()=='SELECT'><#comment>简单查询</#comment>
            <#--   List<${item.codeName}> ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Page<${item.codeName}> ${apiMethod.getCodeName()?uncap_first}(){
            return null;
     }
            <#elseif apiMethod.getActionType()=='FETCH'><#comment>数据集合</#comment>
    <#--@RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")-->
    public Page<${item.codeName}> ${apiMethod.getCodeName()?uncap_first?replace("fetch","search")}(${refDE.getCodeName()}SearchContext context){
            return null;
     }

            <#elseif apiMethod.getActionType()=='USER'><#comment>用户自定义</#comment>
    public void ${apiMethod.getCodeName()?uncap_first}(){
            return null;
     }
            </#if>

        </#list>
    </#if>
}
</#if>
