<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
    <#if sys.getAllPSApps()??>
    {
    "predefineddatarange":[{"id":"ALL","name":"全部数据"},{"id":"CURORG","name":"当前单位"},{"id":"PORG","name":"上级单位"},{"id":"SORG","name":"下级单位"},{"id":"CURORGDEPT","name":"当前部门"},{"id":"PORGDEPT","name":"上级部门"},{"id":"SORGDEPT","name":"下级部门"}],
    <#assign ct=0>
    "entities":[
        <#list sys.getAllPSApps() as app>
            <#if app.getAllPSAppDataEntities?? && app.getAllPSAppDataEntities()??>
                <#list app.getAllPSAppDataEntities() as appde><#comment>由于平台暂未开放获取实体操作标识的方法，所以暂时写死</#comment>
                    <#assign de=appde.getPSDE()>
                    <#if !P.exists(de.getCodeName(),"")>
                        <#if (ct>0)>
    ,</#if><#assign ct=ct+1>
    <#assign dataSetResult=getDataSet()>
    <#assign deActionResult=getDEAction()>
    {
    "dename":"${de.codeName}",
    "delogicname":"${de.logicName}",
    "sysmoudle":{"id":"${de.getPSSystemModule().codeName?upper_case}","name":"${de.getPSSystemModule().name}"},
    "dedataset":${dataSetResult},
    "deaction":${deActionResult}
     }
                    </#if>
                </#list>
            </#if>
        </#list>
    ]

    }
    </#if>

<#comment>获取实体数据集</#comment>
<#function getDataSet>
    <#assign result="[" >
    <#if de.getAllPSDEDataSets()??>
        <#list de.getAllPSDEDataSets() as dataSet>
            <#if dataSet_index gt 0><#assign result=result+","></#if>
            <#assign dataSetLogicName="">
            <#if dataSet.getLogicName()?? && dataSet.getLogicName()!=''><#assign dataSetLogicName=dataSet.getLogicName()><#else><#assign dataSetLogicName=dataSet.codeName></#if>
            <#assign result=result+"{\"id\":\""+dataSet.codeName+"\" , \"name\":\""+dataSetLogicName+"\"}">
        </#list>
    </#if>
    <#assign result=result+"]" >
    <#return result>
</#function>

<#comment>获取实体行为</#comment>
<#function getDEAction>
    <#assign result="[" >
    <#if de.getAllPSDEActions()??>
        <#list de.getAllPSDEActions() as deAction>
            <#if deAction_index gt 0><#assign result=result+","></#if>
            <#assign deActionLogicName="">
            <#if deAction.getLogicName()?? && deAction.getLogicName()!=''><#assign deActionLogicName=deAction.getLogicName()><#else><#assign deActionLogicName=deAction.codeName></#if>
            <#assign result=result+"{\"id\":\""+deAction.codeName+"\" , \"name\":\""+deActionLogicName+"\" , \"type\":\""+deAction.getActionType()+"\" }">
        </#list>
    </#if>
    <#assign result=result+"]" >
    <#return result>
</#function>

